%{!?tcl_sitearch: %define tcl_sitearch %{_libdir}/tcl%(echo 'puts $tcl_version' | tclsh)}

Summary: TclXML is a package that provides XML parsing for the Tcl scripting language
Name:    tclxml
Version: 3.1
Release: 13%{?dist}
License: BSD
Group:   Development/Libraries
URL:     http://tclxml.sourceforge.net/
Source:  http://downloads.sourceforge.net/tclxml/tclxml-3.1.tar.gz
Patch0:  tclxml.patch
Patch1:  tclxml-3.1-sgmlversion.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  tcl-devel libxml2-devel expat-devel
Requires:       tcl(abi) = 8.5 tcllib

%description
TclXML is a package that provides XML parsing for the Tcl scripting language.
It has three implementations of XML parsers: one written purely in Tcl
and wrappers for the expat and Gnome libxml2 C libraries.

%package expat
Summary: The Tcl xml parser built with the expat xml parser
Group: Development/Libraries
Requires:       %{name} = %{version}-%{release}
%description expat
TclXML is a package that provides optimized XML parsing for the Tcl
scripting language.  This implementation is built against the expat XML
parser.

%package libxml2
Summary: The Tcl xml parser built with the libxml2 xml parser
Group: Development/Libraries
Requires:       %{name} = %{version}-%{release}
%description libxml2
TclXML is a package that provides optimized XML parsing for the Tcl
scripting language.  This implementation is built against the libxml2
xml parser.

%package devel
Summary: Development files for the tclxml packages
Group: Development/Libraries
Requires:       %{name} = %{version}-%{release}
%description devel
Development header files for the tclxml packages.  This includes the
header files for the base, expat, and libxml2 subpackages.

%prep
%setup -q
%patch0 -p1
%patch1

# Clean up rpmlint warning about line endings on
# one of the documentation files.
%{__sed} -i 's/\r//' doc/README.xml

# Remove execute permission bits on the source files to
# clean up rpmlint warnings. 
chmod a-x README ChangeLog
chmod a-x include/tclxml/tclxml.h
chmod a-x expat/xmltok/*.c
chmod a-x expat/xmltok/*.h
chmod a-x expat/xmlwf/*.h
chmod a-x expat/xmlwf/*.c
chmod a-x expat/xmlparse/*.h
chmod a-x expat/xmlparse/*.c
chmod a-x libxml2/*.c
chmod a-x tclexpat.c
chmod a-x tclxml.c

%build
%configure
make %{?_smp_mflags}

cd expat
%configure --with-Tclxml=..
make %{?_smp_mflags}

cd ../libxml2
%configure --with-Tclxml=..
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
cd expat
make install DESTDIR=$RPM_BUILD_ROOT
cd ../libxml2
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{tcl_sitearch}
mv $RPM_BUILD_ROOT%{_libdir}/Tclxml3.1 $RPM_BUILD_ROOT%{tcl_sitearch}/
mv $RPM_BUILD_ROOT%{_libdir}/TclXML_libxml23.1 $RPM_BUILD_ROOT%{tcl_sitearch}/%{name}-libxml2-%{version}
mv $RPM_BUILD_ROOT%{_libdir}/Tclexpat3.1 $RPM_BUILD_ROOT%{tcl_sitearch}/%{name}-expat-%{version}

# Remove the following header files which really don't need
# to be installed.  They conflict with headers from
# libwww-devel
rm -f $RPM_BUILD_ROOT/usr/include/xmlparse.h
rm -f $RPM_BUILD_ROOT/usr/include/xmltok.h
rm -f $RPM_BUILD_ROOT/usr/include/xmlrole.h

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%dir %{tcl_sitearch}/Tclxml%{version}
%{tcl_sitearch}/Tclxml%{version}/*.so
%{tcl_sitearch}/Tclxml%{version}/*.tcl
%doc LICENSE ANNOUNCE ChangeLog README RELNOTES
%doc doc/*

%files expat
%defattr(-,root,root)
%{tcl_sitearch}/%{name}-expat-%{version}

%files libxml2
%defattr(-,root,root)
%{tcl_sitearch}/%{name}-libxml2-%{version}

%files devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/TclxmlConfig.sh
%{tcl_sitearch}/Tclxml%{version}/*.a

%changelog
* Sat Feb 8 2008 Wart <wart at kobold.org> - 3.1-13
- Better download URL
- rebuild for gcc 4.3

* Thu Jan 3 2008 Wart <wart at kobold.org> - 3.1-12
- Rebuild for Tcl 8.5

* Sun Feb 4 2007 Wart <wart at kobold.org> - 3.1-11
- Move package directory back to %%{_libdir} until %%{tcl_sitearch}
  is part of the default package search path in Tcl.

* Fri Feb 2 2007 Wart <wart at kobold.org> - 3.1-10
- Fix sgmlparser version mismatch
- Move package directories to tcl-specific directories

* Mon Aug 28 2006 Wart <wart at kobold.org> - 3.1-9
- Rebuild for Fedora Extras

* Thu Jun 1 2006 Wart <wart at kobold.org> - 3.1-8
- Fixed Requires: for subpackages

* Tue Feb 21 2006 Wart <wart at kobold.org> - 3.1-7
- Rebuild for FC5

* Wed Jan 11 2006 Wart <wart at kobold.org> - 3.1-6
- Remove broken parts of patch
- Clean up build root before installing.

* Wed Jan 11 2006 Wart <wart at kobold.org> - 3.1-5
- Added missing ChangeLog entries.

* Wed Jan 11 2006 Wart <wart at kobold.org> - 3.1-4
- Retag to fix tag problem.

* Wed Jan 11 2006 Wart <wart at kobold.org> - 3.1-3
- Updated patch to fix quoting bug with bash >= 3.1

* Sun Jan 8 2006 Wart <wart at kobold.org> - 3.1-2
- Package now owns the directories that it creates.

* Sat Nov 26 2005 Wart <wart at kobold.org> - 3.1-1
- Update to new upstream sources.

* Sat Nov 26 2005 Wart <wart at kobold.org> - 3.0-3
- Remove dependency on dos2unix with clever sed command.

* Fri Nov 25 2005 Wart <wart at kobold.org> - 3.0-2
- Fix file permissions to clean up rpmlint warnings.
- Add BR: dos2unix to remove DOS line endings on a documentation file.
- Other minor fixes to clean up rpmlint warnings.

* Fri Jun 17 2005 Wart <wart at kobold.org> - 3.0-1
- Updated spec file to conform to Fedora Core 4 standards.
- Move autoreconf from the build to the prep stage.

* Tue Jan 18 2005 Wart <wart at kobold.org> - 3.0-0.fdr.5
- Fix typo in version string for subpackage dependencies.
- Don't include the .a library in the base package.

* Fri Nov 5 2004 Wart <wart at kobold.org> - 3.0-0.fdr.4
- Add epoch to version dependencies in spec file.
- Added additional doc files.

* Thu Nov 4 2004 Wart <wart at kobold.org> - 3.0-0.fdr.3
- enable building on x86_64

* Thu Nov 4 2004 Wart <wart at kobold.org> - 3.0-0.fdr.2
- Clean up rpmlint warnings.

* Thu Nov 4 2004 Wart <wart at kobold.org> - 3.0-0.fdr.1
- Added Fedora-style spec file.
- Allow building generic RPMs from the Makefile.
- Fix VPATH problems with newer versions of autoconf tools.
